/** @file fft2d_cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.1
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef FFT2D_CMDLINE_H
#define FFT2D_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef FFT2D_PARSER_PACKAGE
/** @brief the program name */
#define FFT2D_PARSER_PACKAGE "fft2d"
#endif

#ifndef FFT2D_PARSER_VERSION
/** @brief the program version */
#define FFT2D_PARSER_VERSION "1.0"
#endif

/** @brief Where the command line options are stored */
struct fft2d_cmd_struct
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int size_arg;	/**< @brief number of elements in each dimension (default='800').  */
  char * size_orig;	/**< @brief number of elements in each dimension original value given at command line.  */
  const char *size_help; /**< @brief number of elements in each dimension help description.  */
  int check_arg;	/**< @brief check (default='0').  */
  char * check_orig;	/**< @brief check original value given at command line.  */
  const char *check_help; /**< @brief check help description.  */
  int debug_arg;	/**< @brief debug (default='0').  */
  char * debug_orig;	/**< @brief debug original value given at command line.  */
  const char *debug_help; /**< @brief debug help description.  */
  int flops_arg;	/**< @brief flops (default='0').  */
  char * flops_orig;	/**< @brief flops original value given at command line.  */
  const char *flops_help; /**< @brief flops help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int size_given ;	/**< @brief Whether size was given.  */
  unsigned int check_given ;	/**< @brief Whether check was given.  */
  unsigned int debug_given ;	/**< @brief Whether debug was given.  */
  unsigned int flops_given ;	/**< @brief Whether flops was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct fft2d_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure fft2d_cmd_struct (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure fft2d_cmd_struct (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *fft2d_cmd_struct_purpose;
/** @brief the usage string of the program */
extern const char *fft2d_cmd_struct_usage;
/** @brief all the lines making the help output */
extern const char *fft2d_cmd_struct_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int fft2d_parser (int argc, char * const *argv,
  struct fft2d_cmd_struct *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use fft2d_parser_ext() instead
 */
int fft2d_parser2 (int argc, char * const *argv,
  struct fft2d_cmd_struct *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int fft2d_parser_ext (int argc, char * const *argv,
  struct fft2d_cmd_struct *args_info,
  struct fft2d_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int fft2d_parser_dump(FILE *outfile,
  struct fft2d_cmd_struct *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int fft2d_parser_file_save(const char *filename,
  struct fft2d_cmd_struct *args_info);

/**
 * Print the help
 */
void fft2d_parser_print_help(void);
/**
 * Print the version
 */
void fft2d_parser_print_version(void);

/**
 * Initializes all the fields a fft2d_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void fft2d_parser_params_init(struct fft2d_parser_params *params);

/**
 * Allocates dynamically a fft2d_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized fft2d_parser_params structure
 */
struct fft2d_parser_params *fft2d_parser_params_create(void);

/**
 * Initializes the passed fft2d_cmd_struct structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void fft2d_parser_init (struct fft2d_cmd_struct *args_info);
/**
 * Deallocates the string fields of the fft2d_cmd_struct structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void fft2d_parser_free (struct fft2d_cmd_struct *args_info);

/**
 * The string parser (interprets the passed string as a command line)
 * @param cmdline the command line stirng
 * @param args_info the structure where option information will be stored
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int fft2d_parser_string (const char *cmdline, struct fft2d_cmd_struct *args_info,
  const char *prog_name);
/**
 * The string parser (version with additional parameters - deprecated)
 * @param cmdline the command line stirng
 * @param args_info the structure where option information will be stored
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use fft2d_parser_string_ext() instead
 */
int fft2d_parser_string2 (const char *cmdline, struct fft2d_cmd_struct *args_info,
  const char *prog_name,
  int override, int initialize, int check_required);
/**
 * The string parser (version with additional parameters)
 * @param cmdline the command line stirng
 * @param args_info the structure where option information will be stored
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int fft2d_parser_string_ext (const char *cmdline, struct fft2d_cmd_struct *args_info,
  const char *prog_name,
  struct fft2d_parser_params *params);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int fft2d_parser_required (struct fft2d_cmd_struct *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* FFT2D_CMDLINE_H */
